"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DataRenderer = exports.ChoiceRenderer = exports.DocumentRenderer = exports.ValueRenderer = exports.PropertyHeader = exports.PropertyRenderer = exports.ObjectRenderer = exports.TypeRenderer = exports.IDRenderer = exports.ObjectHeader = exports.ObjectSummary = exports.PageActions = exports.FancyPageHeader = exports.FancyRenderer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactstrap = require("reactstrap");

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _reactSelect = _interopRequireDefault(require("react-select"));

var _reactTextareaAutosize = _interopRequireDefault(require("react-textarea-autosize"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var styles = {
  fancyPage: {},
  fancyPageHeader: {
    padding: "1em !important",
    height: "auto !important",
    border: "0 !important",
    fontSize: "3em"
  }
};
var headerstyle = {
  borderRadius: "6px 0 0 0",
  padding: "6px",
  backgroundColor: "#efefef",
  color: "#888"
};
var labelstyle = {};
var valuestyle = {};

var FancyRenderer = function FancyRenderer(_ref) {
  var frame = _ref.frame,
      mode = _ref.mode,
      view = _ref.view,
      errors = _ref.errors;
  if (!frame) return false;
  return /*#__PURE__*/_react["default"].createElement("span", {
    style: styles.fancyPage
  }, /*#__PURE__*/_react["default"].createElement(FancyPageHeader, {
    frame: frame.document,
    mode: mode,
    view: view
  }), /*#__PURE__*/_react["default"].createElement(ObjectRenderer, {
    frame: frame.document,
    mode: mode,
    view: view
  }));
};

exports.FancyRenderer = FancyRenderer;

var FancyPageHeader = function FancyPageHeader(_ref2) {
  var frame = _ref2.frame,
      mode = _ref2.mode,
      view = _ref2.view;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      active = _useState2[0],
      setActive = _useState2[1];

  var toggleActive = function toggleActive() {
    return setActive(!active);
  };

  var type = _terminusdbClient["default"].UTILS.shorten(frame.subjectClass());

  var lab = frame.first("rdfs:label");
  var desc = frame.first("rdfs:comment");

  var id = _terminusdbClient["default"].UTILS.shorten(frame.subject()); //if(mode == "edit"){


  return /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, {
    onMouseEnter: toggleActive,
    onMouseLeave: toggleActive
  }, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 1
  }, active && /*#__PURE__*/_react["default"].createElement(PageActions, null)), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 10
  }, /*#__PURE__*/_react["default"].createElement(_reactTextareaAutosize["default"], {
    minRows: 1,
    className: "wiki wiki-title",
    placeholder: "Enter " + type + "  name"
  }, lab), /*#__PURE__*/_react["default"].createElement(_reactTextareaAutosize["default"], {
    minRows: 1,
    className: "wiki wiki-description",
    placeholder: "Enter " + type + " description"
  }, desc)), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 1
  }, active && /*#__PURE__*/_react["default"].createElement(PageActions, null)));
};

exports.FancyPageHeader = FancyPageHeader;

var PageActions = function PageActions(_ref3) {
  var frame = _ref3.frame,
      mode = _ref3.mode,
      view = _ref3.view;

  var onAddProp = function onAddProp(e) {
    frame.addProperty(e.value);
    setRedraw(redraw + 1);
  };

  var getMissingPropertySelector = function getMissingPropertySelector() {
    var mpl = frame.getMissingPropertyList();

    if (Object.keys(mpl).length) {
      return /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], {
        onChange: onAddProp,
        options: mpl,
        placeholder: "Add Property"
      });
    }

    return null;
  };

  return /*#__PURE__*/_react["default"].createElement("button", null, "+");
};

exports.PageActions = PageActions;

var ObjectSummary = function ObjectSummary(_ref4) {
  var frame = _ref4.frame,
      mode = _ref4.mode,
      view = _ref4.view;
  return /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, "yo"));
};

exports.ObjectSummary = ObjectSummary;

var ObjectHeader = function ObjectHeader(_ref5) {
  var frame = _ref5.frame,
      mode = _ref5.mode,
      view = _ref5.view;

  var _useState3 = (0, _react.useState)(frame.subject()),
      _useState4 = _slicedToArray(_useState3, 2),
      oid = _useState4[0],
      setOid = _useState4[1];

  var _useState5 = (0, _react.useState)(frame.subjectClass()),
      _useState6 = _slicedToArray(_useState5, 2),
      otype = _useState6[0],
      setOtype = _useState6[1];

  var showid = false;
  var showtype = false;

  var updateID = function updateID(nid) {
    frame.subjid = nid;
    setOid(nid);
  };

  var updateType = function updateType(ntype) {
    frame.cls = ntype;
    setOtype(ntype);
  };

  return null;
  return /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, "yo"));
};

exports.ObjectHeader = ObjectHeader;

var IDRenderer = function IDRenderer(_ref6) {
  var id = _ref6.id,
      mode = _ref6.mode,
      view = _ref6.view,
      update = _ref6.update;

  var onc = function onc(e) {
    update(e.target.value);
  };

  return /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", {
    style: labelstyle
  }, "ID"), mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", null), /*#__PURE__*/_react["default"].createElement("td", {
    style: valuestyle
  }, mode != "edit" && /*#__PURE__*/_react["default"].createElement("span", null, _terminusdbClient["default"].UTILS.shorten(id)), mode == "edit" && /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, /*#__PURE__*/_react["default"].createElement("input", {
    type: "text",
    value: _terminusdbClient["default"].UTILS.shorten(id),
    onChange: onc
  })), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null))));
};

exports.IDRenderer = IDRenderer;

var TypeRenderer = function TypeRenderer(_ref7) {
  var type = _ref7.type,
      mode = _ref7.mode,
      view = _ref7.view,
      update = _ref7.update;

  var onc = function onc(e) {
    update(e.target.value);
  };

  return /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", {
    style: labelstyle
  }, "Type"), mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", null), /*#__PURE__*/_react["default"].createElement("td", {
    style: valuestyle
  }, mode != "edit" && /*#__PURE__*/_react["default"].createElement("span", null, _terminusdbClient["default"].UTILS.shorten(type)), mode == "edit" && /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, /*#__PURE__*/_react["default"].createElement("input", {
    type: "text",
    value: _terminusdbClient["default"].UTILS.shorten(type),
    onChange: onc
  })), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null))));
};

exports.TypeRenderer = TypeRenderer;

var ObjectRenderer = function ObjectRenderer(_ref8) {
  var frame = _ref8.frame,
      mode = _ref8.mode,
      view = _ref8.view;
  if (!frame) return null;

  var _useState7 = (0, _react.useState)(1),
      _useState8 = _slicedToArray(_useState7, 2),
      redraw = _useState8[0],
      setRedraw = _useState8[1];

  var initiallyExpanded = function initiallyExpanded(frame) {
    if (frame.depth() == 0) {
      return true;
    }

    return !frame.display_options.collapse;
  };

  var _useState9 = (0, _react.useState)(initiallyExpanded(frame)),
      _useState10 = _slicedToArray(_useState9, 2),
      expanded = _useState10[0],
      setExpanded = _useState10[1];

  var renderProperties = function renderProperties() {
    var props = [];

    for (var p in frame.properties) {
      var vframe = frame.properties[p];
      if (Array.isArray(vframe)) vframe = vframe[0];

      if (p != "rdfs:label" && p != "rdfs:comment") {
        props = props.concat( /*#__PURE__*/_react["default"].createElement(PropertyRenderer, {
          view: view,
          key: p + "_property",
          frame: vframe,
          mode: mode
        }));
      }
    }

    return props;
  };

  if (!expanded) {
    return /*#__PURE__*/_react["default"].createElement(ObjectSummary, {
      view: view,
      frame: frame,
      mode: mode
    });
  } else {
    var props = renderProperties();
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(ObjectHeader, {
      view: view,
      frame: frame,
      mode: mode
    }), props);
  }
};

exports.ObjectRenderer = ObjectRenderer;

var PropertyRenderer = function PropertyRenderer(_ref9) {
  var frame = _ref9.frame,
      mode = _ref9.mode,
      view = _ref9.view;
  if (!frame) return null;

  var _useState11 = (0, _react.useState)(1),
      _useState12 = _slicedToArray(_useState11, 2),
      redraw = _useState12[0],
      setRedraw = _useState12[1];

  var _useState13 = (0, _react.useState)(),
      _useState14 = _slicedToArray(_useState13, 2),
      rvals = _useState14[0],
      setRvals = _useState14[1];

  var delstyle = {
    padding: "4px"
  };
  (0, _react.useEffect)(function () {
    return setRvals(getPvals());
  }, [frame, mode]);

  if (!frame.getLabel) {
    console.log("strange frame", frame);
    return null;
  }

  function addValue() {
    frame.addValueFrame(frame.createEmpty());
    setRvals(getPvals());
    setRedraw(redraw + 1);
  }

  var deleteValue = function deleteValue(val, index) {
    frame.removeValue(val);
    setRvals(getPvals());
    setRedraw(redraw + 1);
  };

  function getLabelPart(len) {
    return /*#__PURE__*/_react["default"].createElement("td", {
      key: frame.predicate + "_label",
      style: labelstyle,
      rowSpan: len
    }, mode == "edit" && /*#__PURE__*/_react["default"].createElement("button", {
      onClick: addValue
    }, "+"), frame.getLabel());
  }

  function getPvals() {
    var vals = [];

    var isDup = function isDup(val) {
      if (vals.indexOf(val) == -1) {
        vals.push(val);
        return false;
      }

      return true;
    };

    var rvals = [];

    for (var i = 0; i < frame.values.length; i++) {
      if (!isDup(frame.values[i].get())) {
        rvals.push(frame.values[i]);
      }
    }

    return rvals;
  }

  function getDelVal(index, vframe) {
    var g = vframe.get();

    var f = function f() {
      deleteValue(g, index);
    };

    return f;
  }

  if (!rvals || !rvals.length) return null;
  var rows = [];

  for (var i = 0; i < rvals.length; i++) {
    rows.push( /*#__PURE__*/_react["default"].createElement(ValueRenderer, {
      key: frame.predicate + "_" + i,
      redraw: redraw,
      frame: rvals[i],
      mode: mode,
      view: view
    }));
  }

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(PropertyHeader, {
    frame: frame,
    mode: mode,
    view: view
  }), rows);
};

exports.PropertyRenderer = PropertyRenderer;

var PropertyHeader = function PropertyHeader(_ref10) {
  var frame = _ref10.frame,
      mode = _ref10.mode,
      view = _ref10.view,
      index = _ref10.index;

  var _useState15 = (0, _react.useState)(false),
      _useState16 = _slicedToArray(_useState15, 2),
      active = _useState16[0],
      setActive = _useState16[1];

  var toggleActive = function toggleActive() {
    return setActive(!active);
  };

  var getHeaderTag = function getHeaderTag() {
    var l = frame.depth() + 2;
    var cname = "wiki-property-header wiki-propery-header-" + l;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: cname
    }, frame.getLabel());
  };

  return /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, {
    onMouseEnter: toggleActive,
    onMouseLeave: toggleActive
  }, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 1
  }, active && /*#__PURE__*/_react["default"].createElement(PageActions, null)), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 10
  }, getHeaderTag()), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 1
  }, active && /*#__PURE__*/_react["default"].createElement(PageActions, null)));
};

exports.PropertyHeader = PropertyHeader;

var ValueRenderer = function ValueRenderer(_ref11) {
  var frame = _ref11.frame,
      mode = _ref11.mode,
      view = _ref11.view,
      redraw = _ref11.redraw;

  var _useState17 = (0, _react.useState)(false),
      _useState18 = _slicedToArray(_useState17, 2),
      v = _useState18[0],
      setV = _useState18[1];

  (0, _react.useEffect)(function () {
    return setV(frame.get());
  }, [redraw, frame]);

  var updval = function updval(vv) {
    setV(vv);
    frame.set(vv);
  };

  if (v === false) return null;

  if (!frame.isData()) {
    return /*#__PURE__*/_react["default"].createElement(ObjectRenderer, {
      frame: frame,
      view: view,
      mode: mode
    });
  } else if (frame.isChoice()) {
    return /*#__PURE__*/_react["default"].createElement(ChoiceRenderer, {
      val: v,
      frame: frame,
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else if (frame.isDocument()) {
    return /*#__PURE__*/_react["default"].createElement(DocumentRenderer, {
      val: v,
      frame: frame,
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else if (frame.isData()) {
    return /*#__PURE__*/_react["default"].createElement(DataRenderer, {
      val: v,
      type: frame.getType(),
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else {
    alert("Frame has no known type");
    console.log(frame);
  }
};

exports.ValueRenderer = ValueRenderer;

var DocumentRenderer = function DocumentRenderer(_ref12) {
  var val = _ref12.val,
      mode = _ref12.mode,
      frame = _ref12.frame,
      updateVal = _ref12.updateVal,
      view = _ref12.view;

  var _useState19 = (0, _react.useState)(false),
      _useState20 = _slicedToArray(_useState19, 2),
      active = _useState20[0],
      setActive = _useState20[1];

  var toggleActive = function toggleActive() {
    return setActive(!active);
  };

  return /*#__PURE__*/_react["default"].createElement(DataRenderer, {
    val: val,
    mode: mode,
    type: frame.getType(),
    updateVal: updateVal
  });
};

exports.DocumentRenderer = DocumentRenderer;

var ChoiceRenderer = function ChoiceRenderer(_ref13) {
  var val = _ref13.val,
      mode = _ref13.mode,
      frame = _ref13.frame,
      updateVal = _ref13.updateVal;

  var _useState21 = (0, _react.useState)(false),
      _useState22 = _slicedToArray(_useState21, 2),
      active = _useState22[0],
      setActive = _useState22[1];

  var toggleActive = function toggleActive() {
    return setActive(!active);
  };

  var lab = val || "Select from choices";
  var opts = frame.frame.elements.map(function (item) {
    if (_terminusdbClient["default"].UTILS.compareIDs(item["class"], val)) {
      lab = item.label["@value"];
    }

    return {
      value: _terminusdbClient["default"].UTILS.shorten(item["class"]),
      label: item.label["@value"]
    };
  });

  var onChange = function onChange(e) {
    updateVal(e.value);
  };

  return /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, {
    onMouseEnter: toggleActive,
    onMouseLeave: toggleActive
  }, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 1
  }, active && /*#__PURE__*/_react["default"].createElement(PageActions, null)), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 10
  }, /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], {
    defaultValue: val,
    isClearable: true,
    onChange: onChange,
    options: opts,
    placeholder: lab
  })), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 1
  }, active && /*#__PURE__*/_react["default"].createElement(PageActions, null)));
};

exports.ChoiceRenderer = ChoiceRenderer;

var DataRenderer = function DataRenderer(_ref14) {
  var val = _ref14.val,
      mode = _ref14.mode,
      type = _ref14.type,
      updateVal = _ref14.updateVal;

  var _useState23 = (0, _react.useState)(false),
      _useState24 = _slicedToArray(_useState23, 2),
      active = _useState24[0],
      setActive = _useState24[1];

  var toggleActive = function toggleActive() {
    return setActive(!active);
  };

  var onc = function onc(e) {
    updateVal(e.target.value);
  };

  var mv = val ? "" + val : "";
  return /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, {
    onMouseEnter: toggleActive,
    onMouseLeave: toggleActive
  }, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 1
  }, active && /*#__PURE__*/_react["default"].createElement(PageActions, null)), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 10
  }, /*#__PURE__*/_react["default"].createElement(_reactTextareaAutosize["default"], {
    minRows: 1,
    className: "wiki wiki-property",
    placeholder: "Enter " + type + "  name"
  }, mv)), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, {
    md: 1
  }, active && /*#__PURE__*/_react["default"].createElement(PageActions, null)));
};

exports.DataRenderer = DataRenderer;