"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DataRenderer = exports.ChoiceRenderer = exports.FrameError = exports.FrameErrors = exports.DocumentRenderer = exports.ValueRenderer = exports.PropertyRenderer = exports.TypeRenderer = exports.IDRenderer = exports.ObjectRenderer = exports.TableRenderer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactstrap = require("reactstrap");

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _reactSelect = _interopRequireDefault(require("react-select"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var valuestyle = {
  padding: "0.5em"
};
var labelstyle = {
  backgroundColor: "#efefef",
  fontWeight: 600,
  borderRadius: "0 0 0 6px",
  textAlign: "right",
  padding: "6px",
  borderBottom: "1px solid white",
  width: "150px"
};
var tabstyle = {
  width: "100%"
};

var TableRenderer = function TableRenderer(_ref) {
  var frame = _ref.frame,
      mode = _ref.mode,
      view = _ref.view,
      errors = _ref.errors;

  var _useState = (0, _react.useState)(0),
      _useState2 = _slicedToArray(_useState, 2),
      ping = _useState2[0],
      setPing = _useState2[1];

  (0, _react.useEffect)(function () {
    if (errors) {
      var frameconf = _terminusdbClient["default"].View.document();

      frame.setErrors(errors, frameconf);
      setPing(ping + 1);
    }
  }, [errors]);
  return /*#__PURE__*/_react["default"].createElement("table", {
    style: tabstyle
  }, /*#__PURE__*/_react["default"].createElement(ObjectRenderer, {
    frame: frame.document,
    mode: mode,
    view: view,
    ping: ping
  }));
};

exports.TableRenderer = TableRenderer;

var ObjectRenderer = function ObjectRenderer(_ref2) {
  var frame = _ref2.frame,
      mode = _ref2.mode,
      view = _ref2.view,
      ping = _ref2.ping;
  if (!frame) return null;

  var _useState3 = (0, _react.useState)(1),
      _useState4 = _slicedToArray(_useState3, 2),
      redraw = _useState4[0],
      setRedraw = _useState4[1];

  var _useState5 = (0, _react.useState)(frame.subject()),
      _useState6 = _slicedToArray(_useState5, 2),
      oid = _useState6[0],
      setOid = _useState6[1];

  var _useState7 = (0, _react.useState)(frame.subjectClass()),
      _useState8 = _slicedToArray(_useState7, 2),
      otype = _useState8[0],
      setOtype = _useState8[1];

  var showid = view && view.show_id && frame.depth() == 0 ? view.show_id : false;
  var showtype = view && view.show_type ? view.show_type : false;
  var headerstyle = {
    borderRadius: "6px 0 0 0",
    padding: "6px",
    backgroundColor: "#efefef",
    color: "#888"
  };
  var header2style = {
    padding: "6px",
    backgroundColor: "#efefef",
    color: "#888"
  };

  var onAddProp = function onAddProp(e) {
    frame.addProperty(e.value);
    setRedraw(redraw + 1);
  };

  var getMissingPropertySelector = function getMissingPropertySelector() {
    var mpl = frame.getMissingPropertyList();

    if (Object.keys(mpl).length) {
      return /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], {
        onChange: onAddProp,
        options: mpl,
        placeholder: "Add Property"
      });
    }

    return null;
  };

  var updateID = function updateID(nid) {
    frame.subjid = nid;
    setOid(nid);
  };

  var updateType = function updateType(ntype) {
    frame.cls = ntype;
    setOtype(ntype);
  };

  var renderProperties = function renderProperties() {
    var props = [];

    for (var p in frame.properties) {
      var pframe = frame.properties[p]; //let nvframe = (Array.isArray(vframe) ? vframe[0] : vframe)

      props = props.concat( /*#__PURE__*/_react["default"].createElement(PropertyRenderer, {
        ping: ping,
        view: view,
        key: p + "_property",
        frame: pframe,
        mode: mode
      }));
    }

    return props;
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("thead", null, /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("th", {
    colSpan: "2",
    style: headerstyle,
    title: frame.subject()
  }, frame.subjectClass()), mode == "edit" && /*#__PURE__*/_react["default"].createElement("th", {
    style: headerstyle
  }, /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, getMissingPropertySelector()), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null))))), /*#__PURE__*/_react["default"].createElement("tbody", null, showid && /*#__PURE__*/_react["default"].createElement(IDRenderer, {
    id: oid,
    mode: mode,
    view: view,
    update: updateID
  }), showtype && /*#__PURE__*/_react["default"].createElement(TypeRenderer, {
    type: otype,
    mode: mode,
    view: view,
    update: updateType
  }), renderProperties()));
};

exports.ObjectRenderer = ObjectRenderer;

var IDRenderer = function IDRenderer(_ref3) {
  var id = _ref3.id,
      mode = _ref3.mode,
      view = _ref3.view,
      update = _ref3.update;

  var onc = function onc(e) {
    update(e.target.value);
  };

  return /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", {
    style: labelstyle
  }, "ID"), mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", null), /*#__PURE__*/_react["default"].createElement("td", {
    style: valuestyle
  }, mode != "edit" && /*#__PURE__*/_react["default"].createElement("span", null, _terminusdbClient["default"].UTILS.shorten(id)), mode == "edit" && /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, /*#__PURE__*/_react["default"].createElement("input", {
    type: "text",
    value: _terminusdbClient["default"].UTILS.shorten(id),
    onChange: onc
  })), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null))));
};

exports.IDRenderer = IDRenderer;

var TypeRenderer = function TypeRenderer(_ref4) {
  var type = _ref4.type,
      mode = _ref4.mode,
      view = _ref4.view,
      update = _ref4.update;

  var onc = function onc(e) {
    update(e.target.value);
  };

  return /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", {
    style: labelstyle
  }, "Type"), mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", null), /*#__PURE__*/_react["default"].createElement("td", {
    style: valuestyle
  }, mode != "edit" && /*#__PURE__*/_react["default"].createElement("span", null, _terminusdbClient["default"].UTILS.shorten(type)), mode == "edit" && /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, /*#__PURE__*/_react["default"].createElement("input", {
    type: "text",
    value: _terminusdbClient["default"].UTILS.shorten(type),
    onChange: onc
  })), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null))));
};

exports.TypeRenderer = TypeRenderer;

var PropertyRenderer = function PropertyRenderer(_ref5) {
  var frame = _ref5.frame,
      mode = _ref5.mode,
      view = _ref5.view,
      ping = _ref5.ping;
  if (!frame) return null;

  var _useState9 = (0, _react.useState)(1),
      _useState10 = _slicedToArray(_useState9, 2),
      redraw = _useState10[0],
      setRedraw = _useState10[1];

  var _useState11 = (0, _react.useState)(),
      _useState12 = _slicedToArray(_useState11, 2),
      rvals = _useState12[0],
      setRvals = _useState12[1];

  var delstyle = {
    padding: "2px",
    width: "16px",
    textAlign: "center"
  };
  var minusStyle = {
    color: "red",
    fontSize: "2em",
    backgroundColor: "white"
  };
  var plusStyle = {
    color: "green",
    fontSize: "1.3em"
  };
  (0, _react.useEffect)(function () {
    return setRvals(getPvals());
  }, [frame, mode]);

  if (!frame.getLabel) {
    console.log("strange frame", frame);
    return null;
  }

  function addValue() {
    frame.addValueFrame(frame.createEmpty());
    setRvals(getPvals());
    setRedraw(redraw + 1);
  }

  var deleteValue = function deleteValue(val, index) {
    frame.removeValue(val);
    setRvals(getPvals());
    setRedraw(redraw + 1);
  };

  function getLabelPart(len) {
    return /*#__PURE__*/_react["default"].createElement("td", {
      key: frame.predicate + "_label",
      style: labelstyle,
      rowSpan: len
    }, mode == "edit" && /*#__PURE__*/_react["default"].createElement("button", {
      style: plusStyle,
      onClick: addValue
    }, "+"), frame.getLabel());
  }

  function getPvals() {
    var vals = [];

    var isDup = function isDup(val) {
      if (vals.indexOf(val) == -1) {
        vals.push(val);
        return false;
      }

      return true;
    };

    var rvals = [];

    for (var i = 0; i < frame.values.length; i++) {
      if (!isDup(frame.values[i].get())) {
        rvals.push(frame.values[i]);
      }
    }

    return rvals;
  }

  function getDelVal(index, vframe) {
    var g = vframe.get();

    var f = function f() {
      deleteValue(g, index);
    };

    return f;
  }

  if (!rvals || !rvals.length) return null;
  var rows = [];

  for (var i = 0; i < rvals.length; i++) {
    if (i == 0) {
      rows.push( /*#__PURE__*/_react["default"].createElement("tr", {
        key: frame.predicate + "_" + i
      }, getLabelPart(rvals.length), mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", {
        style: delstyle
      }, /*#__PURE__*/_react["default"].createElement("button", {
        style: minusStyle,
        onClick: getDelVal(i, rvals[i])
      }, "-"), " "), /*#__PURE__*/_react["default"].createElement("td", {
        key: frame.predicate + "_value_" + i,
        style: valuestyle
      }, /*#__PURE__*/_react["default"].createElement(ValueRenderer, {
        redraw: redraw,
        frame: rvals[i],
        mode: mode,
        view: view,
        ping: ping
      }))));
    } else {
      rows.push( /*#__PURE__*/_react["default"].createElement("tr", {
        key: frame.predicate + "_" + i
      }, mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", {
        style: delstyle
      }, /*#__PURE__*/_react["default"].createElement("button", {
        style: minusStyle,
        onClick: getDelVal(i, rvals[i])
      }, "-")), /*#__PURE__*/_react["default"].createElement("td", {
        style: valuestyle
      }, /*#__PURE__*/_react["default"].createElement(ValueRenderer, {
        redraw: redraw,
        frame: rvals[i],
        mode: mode,
        view: view,
        ping: ping
      }))));
    }
  }

  return rows;
};

exports.PropertyRenderer = PropertyRenderer;

var ValueRenderer = function ValueRenderer(_ref6) {
  var frame = _ref6.frame,
      mode = _ref6.mode,
      view = _ref6.view,
      redraw = _ref6.redraw,
      ping = _ref6.ping;

  var _useState13 = (0, _react.useState)(""),
      _useState14 = _slicedToArray(_useState13, 2),
      v = _useState14[0],
      setV = _useState14[1];

  (0, _react.useEffect)(function () {
    return setV(frame.get());
  }, [redraw, frame]);

  var updval = function updval(vv) {
    setV(vv);
    frame.set(vv);
  };

  if (!frame.isData()) {
    return /*#__PURE__*/_react["default"].createElement("table", {
      style: tabstyle
    }, /*#__PURE__*/_react["default"].createElement(ObjectRenderer, {
      frame: frame,
      mode: mode,
      view: view
    }));
  } else if (frame.isChoice()) {
    return /*#__PURE__*/_react["default"].createElement(ChoiceRenderer, {
      val: v,
      frame: frame,
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else if (frame.isDocument()) {
    return /*#__PURE__*/_react["default"].createElement(DocumentRenderer, {
      val: v,
      frame: frame,
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else if (frame.isData()) {
    return /*#__PURE__*/_react["default"].createElement(DataRenderer, {
      frame: frame,
      val: v,
      type: frame.getType(),
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else {
    console.log("Frame has no known type", frame);
  }
};

exports.ValueRenderer = ValueRenderer;

var DocumentRenderer = function DocumentRenderer(_ref7) {
  var val = _ref7.val,
      mode = _ref7.mode,
      frame = _ref7.frame,
      updateVal = _ref7.updateVal,
      view = _ref7.view;

  if (mode == "edit") {
    return /*#__PURE__*/_react["default"].createElement(DataRenderer, {
      frame: frame,
      val: val,
      mode: mode,
      type: frame.getType(),
      updateVal: updateVal
    });
  } else {
    var ds = function ds() {
      if (view.selectDocument) view.selectDocument(val);
    };

    var lstyle = {
      cursor: "pointer"
    };
    if (val === "") val = _terminusdbClient["default"].UTILS.shorten(frame.getType());
    return /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, /*#__PURE__*/_react["default"].createElement("span", {
      style: lstyle,
      onClick: ds
    }, val)), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null));
  }
};

exports.DocumentRenderer = DocumentRenderer;

var FrameErrors = function FrameErrors(_ref8) {
  var frame = _ref8.frame,
      view = _ref8.view;

  if (!frame.errors) {
    return null;
  }

  var fes = [];

  for (var i = 0; i < frame.errors.length; i++) {
    fes.push( /*#__PURE__*/_react["default"].createElement(FrameError, {
      error: frame.errors[i]
    }));
  }

  return /*#__PURE__*/_react["default"].createElement("span", null, fes);
};

exports.FrameErrors = FrameErrors;

var FrameError = function FrameError(_ref9) {
  var error = _ref9.error;
  var msg = error && error['vio:message'] ? error['vio:message']["@value"] : error && error['api:message'] ? error['api:message'] : "Error with field";
  return /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      color: "#f84848"
    }
  }, msg);
};

exports.FrameError = FrameError;

var ChoiceRenderer = function ChoiceRenderer(_ref10) {
  var val = _ref10.val,
      mode = _ref10.mode,
      frame = _ref10.frame,
      updateVal = _ref10.updateVal;

  if (mode == "edit") {
    var lab = val || "Select from choices";
    var opts = frame.frame.elements.map(function (item) {
      if (_terminusdbClient["default"].UTILS.compareIDs(item["class"], val)) {
        lab = item.label["@value"];
      }

      return {
        value: _terminusdbClient["default"].UTILS.shorten(item["class"]),
        label: item.label["@value"]
      };
    });

    var onChange = function onChange(e) {
      updateVal(e.value);
    };

    return /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], {
      defaultValue: val,
      isClearable: true,
      onChange: onChange,
      options: opts,
      placeholder: lab
    })), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, frame.errors && /*#__PURE__*/_react["default"].createElement(FrameErrors, {
      frame: frame
    })));
  } else {
    var tit = val;
    var _lab = val;
    frame.frame.elements.map(function (item) {
      if (_terminusdbClient["default"].UTILS.compareIDs(item["class"], val)) {
        tit = val + (item.comment ? " - " + item.comment["@value"] : "");
        _lab = item.label ? item.label["@value"] : _terminusdbClient["default"].UTILS.labelFromURL(item["class"]);
      }
    });
    return /*#__PURE__*/_react["default"].createElement("span", {
      title: tit
    }, _lab);
  }
};

exports.ChoiceRenderer = ChoiceRenderer;

var DataRenderer = function DataRenderer(_ref11) {
  var val = _ref11.val,
      mode = _ref11.mode,
      type = _ref11.type,
      updateVal = _ref11.updateVal,
      frame = _ref11.frame;

  if (mode == "edit") {
    var onc = function onc(e) {
      updateVal(e.target.value);
    };

    var mv = val ? "" + val : "";
    return /*#__PURE__*/_react["default"].createElement(_reactstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, /*#__PURE__*/_react["default"].createElement("input", {
      type: "text",
      value: mv,
      onChange: onc
    })), /*#__PURE__*/_react["default"].createElement(_reactstrap.Col, null, frame.errors && /*#__PURE__*/_react["default"].createElement(FrameErrors, {
      frame: frame
    }), !frame.errors && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, _terminusdbClient["default"].UTILS.shorten(type))));
  } else {
    if (val !== "") return val;
    return _terminusdbClient["default"].UTILS.shorten(type);
  }
};

exports.DataRenderer = DataRenderer;